'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactNative = require('react-native');

var _View = require('./View');

var _View2 = _interopRequireDefault(_View);

var _Header = require('./Header');

var _Header2 = _interopRequireDefault(_Header);

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

var _Footer = require('./Footer');

var _Footer2 = _interopRequireDefault(_Footer);

var _NativeBaseComponent2 = require('../Base/NativeBaseComponent');

var _NativeBaseComponent3 = _interopRequireDefault(_NativeBaseComponent2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _computeProps = require('../../Utils/computeProps');

var _computeProps2 = _interopRequireDefault(_computeProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Container = function (_NativeBaseComponent) {
  _inherits(Container, _NativeBaseComponent);

  function Container() {
    _classCallCheck(this, Container);

    return _possibleConstructorReturn(this, (Container.__proto__ || Object.getPrototypeOf(Container)).apply(this, arguments));
  }

  _createClass(Container, [{
    key: 'isHeaderPresent',
    value: function isHeaderPresent() {
      var headerPresent = false;
      _react2.default.Children.forEach(this.props.children, function (child) {
        if (child.type == _Header2.default) headerPresent = true;
      });
      return headerPresent;
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader() {
      if (Array.isArray(this.props.children)) {
        return _lodash2.default.find(this.props.children, function (item) {
          if (item && item.type == _Header2.default) {
            return true;
          }
        });
      } else {
        if (this.props.children && this.props.children.type == _Header2.default) {
          return this.props.children;
        }
      }
    }
  }, {
    key: 'getBottomTabBarHeight',
    value: function getBottomTabBarHeight() {
      var tabBars = document.getElementsByClassName('tabbarios-tabbar-container');
      if (tabBars.length === 0) {
        return 0;
      }
      var tabBar = tabBars[0];
      if (!(tabBar.clientWidth !== 0 && tabBar.clientHeight !== 0 && tabBar.style.opacity !== 0 && tabBar.style.visibility !== 'hidden')) {
        return 0;
      }
      return tabBars[0].clientHeight;
    }
  }, {
    key: 'renderContent',
    value: function renderContent() {
      var contentNode = null;
      var defaultContentStyle = {
        height: _reactNative.Dimensions.get('window').height - (this.isHeaderPresent() ? this.getTheme().toolbarHeight : 0) - this.getBottomTabBarHeight()
      };

      if (Array.isArray(this.props.children)) {

        contentNode = _lodash2.default.find(this.props.children, function (item) {
          if (item && (item.type == _View2.default || item.type == _Content2.default || item.type == _reactNative.Image || item.type == _reactNative.View)) {

            return true;
          }
        });
      } else {
        if (this.props.children && (this.props.children.type == _Content2.default || this.props.children.type == _View2.default || this.props.children.type == _reactNative.View || this.props.children.type == _reactNative.Image)) {
          contentNode = this.props.children;
        }
      }
      return _react2.default.createElement(
        contentNode.type,
        _extends({}, contentNode.props, { style: _lodash2.default.assign(defaultContentStyle, contentNode.props.style || {}) }),
        contentNode.props.children
      );
    }
  }, {
    key: 'renderFooter',
    value: function renderFooter() {
      if (Array.isArray(this.props.children)) {
        return _lodash2.default.find(this.props.children, function (item) {
          if (item && item.type == _Footer2.default) {
            return true;
          }
        });
      } else {
        if (this.props.children && this.props.children.type == _Footer2.default) {
          return this.props.children;
        }
      }
    }
  }, {
    key: 'prepareRootProps',
    value: function prepareRootProps() {

      var type = {
        flex: 1
      };

      var defaultProps = {
        style: type
      };

      return (0, _computeProps2.default)(this.props, defaultProps);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      if (!this._delayRerendered) {
        // Schedule a delayed update to wait for TabBarIOS
        this._delayRerendered = true;
        setTimeout(function () {
          return _this2.forceUpdate();
        }.bind(this));
        return _react2.default.createElement(_reactNative.View, null);
      }
      return _react2.default.createElement(
        _reactNative.View,
        this.prepareRootProps(),
        _react2.default.createElement(
          _reactNative.View,
          null,
          this.renderHeader()
        ),
        _react2.default.createElement(
          _reactNative.View,
          { style: {
              flex: 1,
              paddingTop: this.isHeaderPresent() ? this.getTheme().toolbarHeight : 0
            } },
          this.renderContent()
        ),
        _react2.default.createElement(
          _reactNative.View,
          null,
          this.renderFooter()
        )
      );
    }
  }]);

  return Container;
}(_NativeBaseComponent3.default);

exports.default = Container;